#include <MyRealTimeClock.h> DS1302 RTC kütüphanesi
#include <LiquidCrystal_I2C_AvrI2C.h> I2C 16x2 Ekran kütüphanesi
#include <SD.h> // sd kart kütüphanesi Arduinı IDE ile otomatik kurulmuş olur
#define Sd_Chip_pin 4 //MicoSD kartın CS haberleşme pini arduino'nun 4 nolu pinine bağlı olduğunu belirttik
#include <TMRpcm.h> // melodi çalma kütüphanesi
#include "SPI.h"
char val;
TMRpcm tmrpcm; // melodi fonksiyonu oluşturma
TMRpcm wav;



MyRealTimeClock myRTC(6, 7, 8); //Or CLK -> 6 , DAT -> 7, Reset -> 8 pinleri arduino'ya ekledik
LiquidCrystal_I2C_AvrI2C lcd(0x27,17,2); //lcd isminde 0x27 adresli bir 17x2 ekran nesnesi oluşturduk 

int anficalistir = 2; //Anfi çalıştırmak için 2 nolu pini çıkış olarak atayacağız
int minareisikyak = 3; //Minare Işıkları için 3 nolu pini çıkış olarak atayacağız
int ramazanayimi=0; //Ramazan ayı içinde 1 yapacağız


void(* resetfunc) (void) = 0; //WAV Dosyası çalıştıkdan sonra RAM'ı boşaltmak için buraya donuyoruz

void setup()
{
  pinMode(anficalistir, OUTPUT); //çıkış olarak ayarlandı
  pinMode(minareisikyak, OUTPUT); //çıkış olarak ayarlandı
  digitalWrite(anficalistir, LOW); //Çıkış LOW yapıldı
  digitalWrite(minareisikyak, LOW); //Çıkış LOW yapıldı

  Serial.begin(9600);
  //myRTC.setDS1302Time(15, 36, 23, 7, 4, 2, 2024);  //(saniye, dakika, saat, haftanın günü, ayın günü, ay, yıl) DS1302'yı ayarlamak için
  lcd.begin(); //lcd'yi başlatıyoruz
  lcd.backlight(); //lcd arka ışığını açıyoruz.
  tmrpcm.speakerPin = 9; // hoparlör + bacağı digital 9. pine tak
  if (!SD.begin(Sd_Chip_pin)) { // sd module bağlandık
  return;
  }
}
void loop()
{
 myRTC.updateTime(); //Guncel Saati bilgisini istiyoruz
 int suanzaman[6]={myRTC.month,myRTC.dayofmonth,myRTC.year,myRTC.hours,myRTC.minutes,myRTC.seconds}; // Saat ve Tarih bilgisini suanzaman içine kaydettik

   int sabahezansaati=1; //Sabah Ezan Vakti için Saatı ayarladık
  int sabahezandakikasi=46; //Sabah Ezan Vakti için Dakikayı ayarladık
  int sabahezansaniyesi=0;

  int oglenezansaati=2; //Öğlen Ezan Vakti için Saatı ayarladık
  int oglenezandakikasi=2; //Öğlen Ezan Vakti için Dakikayı ayarladık
  int oglenezansaniyesi=0;

  int ikindiezansaati=23; //İkindi Ezan Vakti için Saatı ayarladık
  int ikindiezandakikasi=20; //İkindi Ezan Vakti için Dakikayı ayarladık
  int ikindiezansaniyesi=0;

  int aksamezansaati=23; //Akşam Ezan Vakti için Saatı ayarladık
  int aksamezandakikasi=30; //Akşam Ezan Vakti için Dakikayı ayarladık
  int aksamezansaniyesi=0;

  int yatsiezansaati=23; //Yatsı Ezan Vakti için Saatı ayarladık
  int yatsiezandakikasi=40; //Yatsı Ezan Vakti için Dakikayı ayarladık
  int yatsiezansaniyesi=0;



   if (suanzaman[3]==sabahezansaati && suanzaman[4]==sabahezandakikasi && suanzaman[5]==sabahezansaniyesi)  //Şuan Zaman Sabah ezanı zamanına eşit olduğunda çalışacak
  {
  digitalWrite(anficalistir, HIGH); //Anfi Başlatıldı
  lcd.setCursor(0,0);
  lcd.print("EZAN OKUNUYOR...  ");
  lcd.setCursor(0,1);
  lcd.print(" SABAH ");
  lcd.print(myRTC.hours); 
  lcd.print(":"); 
  lcd.print(myRTC.minutes);
  lcd.print(":"); 
  lcd.print(myRTC.seconds);
  lcd.print("          "); 

  tmrpcm.play("1.wav"); // Sabah ezanı SD kartdaki Dosyamız
  tmrpcm.volume(1);  //Sesi yükselttik
  tmrpcm.quality(1); //Ses kalitesi max. yapıldı
  delay(306000); //EZAN OKUNURKEN 5.1 DAKİKA BEKLE
  tmrpcm.stopPlayback(); //WAV dosyası durduruldu
  tmrpcm.disable(); //Kütüphane kapatıldı

  digitalWrite(anficalistir, LOW); //Anfi kapatıldı
  lcd.setCursor(0,0);
  lcd.print("  SABAH EZANI        ");
  lcd.setCursor(0,1);
  lcd.print("EZAN OKUNDU....      ");

  delay(60000);
  resetfunc(); // reser atıldı
  }





else if (suanzaman[3]==oglenezansaati && suanzaman[4]==oglenezandakikasi && suanzaman[5]==oglenezansaniyesi)
  { 
  digitalWrite(anficalistir, HIGH);
  lcd.setCursor(0,0);
  lcd.print("EZAN OKUNUYOR..    ");
  lcd.setCursor(0,1);
  lcd.print(" OGLEN ");
  lcd.print(myRTC.hours); 
  lcd.print(":"); 
  lcd.print(myRTC.minutes);
  lcd.print(":"); 
  lcd.print(myRTC.seconds);
  lcd.print("          "); 

  tmrpcm.play("2.wav"); 
  tmrpcm.volume(1);
  tmrpcm.quality(1);
  delay(210000);//EZAN OKUNURKEN 3,5 DAKİKA BEKLE
  tmrpcm.stopPlayback();
  tmrpcm.disable();

  digitalWrite(anficalistir, LOW);
  lcd.setCursor(0,0);
  lcd.print("  OGLEN EZANI       ");
  lcd.setCursor(0,1);
  lcd.print("EZAN OKUNDU....     ");

  delay(60000);
  resetfunc();
  }





 else if (suanzaman[3]==ikindiezansaati && suanzaman[4]==ikindiezandakikasi && suanzaman[5]==ikindiezansaniyesi)
  { 
  digitalWrite(anficalistir, HIGH);
  lcd.setCursor(0,0);
  lcd.print("EZAN OKUNUYOR..    ");
  lcd.setCursor(0,1);
  lcd.print(" IKINDI ");
  lcd.print(myRTC.hours); 
  lcd.print(":"); 
  lcd.print(myRTC.minutes);
  lcd.print(":"); 
  lcd.print(myRTC.seconds);
  lcd.print("          "); 

  tmrpcm.play("3.wav"); 
  tmrpcm.volume(1);
  tmrpcm.quality(1);
  delay(246000); //EZAN OKUNURKEN 4.1 DAKİKA BEKLE
  tmrpcm.stopPlayback(); 
  tmrpcm.disable();

  digitalWrite(anficalistir, LOW); 
  lcd.setCursor(0,0);
  lcd.print("  IKINDI EZANI       ");
  lcd.setCursor(0,1);
  lcd.print("EZAN OKUNDU....     "); 

  delay(60000);
  resetfunc();  
  }







 else if (suanzaman[3]==aksamezansaati && suanzaman[4]==aksamezandakikasi && suanzaman[5]==aksamezansaniyesi)
  { 
  digitalWrite(anficalistir, HIGH);
  lcd.setCursor(0,0);
  lcd.print("EZAN OKUNUYOR..    ");
  lcd.setCursor(0,1);
  lcd.print(" AKSAM ");
  lcd.print(myRTC.hours); 
  lcd.print(":"); 
  lcd.print(myRTC.minutes);
  lcd.print(":"); 
  lcd.print(myRTC.seconds);
  lcd.print("          "); 

  tmrpcm.play("4.wav"); 
  tmrpcm.volume(1);
  tmrpcm.quality(1);
  delay(147000); //EZAN OKUNURKEN 2,45 DAKİKA BEKLE
  tmrpcm.stopPlayback(); 
  tmrpcm.disable();

  digitalWrite(anficalistir, LOW); 
  lcd.setCursor(0,0);
  lcd.print("  AKSAM EZANI       ");
  lcd.setCursor(0,1);
  lcd.print("EZAN OKUNDU....     ");

  delay(60000);
  resetfunc();
  }







 else if (suanzaman[3]==yatsiezansaati && suanzaman[4]==yatsiezandakikasi && suanzaman[5]==yatsiezansaniyesi)
  { 
  digitalWrite(anficalistir, HIGH);
  lcd.setCursor(0,0);
  lcd.print("EZAN OKUNUYOR..    ");
  lcd.setCursor(0,1);
  lcd.print(" YATSI ");
  lcd.print(myRTC.hours); 
  lcd.print(":"); 
  lcd.print(myRTC.minutes);
  lcd.print(":"); 
  lcd.print(myRTC.seconds);
  lcd.print("          "); 

  tmrpcm.play("5.wav"); 
  tmrpcm.volume(1);
  tmrpcm.quality(1);
  delay(206400);
  tmrpcm.stopPlayback(); 
  tmrpcm.disable();

  digitalWrite(anficalistir, LOW);
  lcd.setCursor(0,0);
  lcd.print("  YATSI EZANI       ");
  lcd.setCursor(0,1);
  lcd.print("EZAN OKUNDU....     ");   

  delay(60000);
  resetfunc();
  }




 else
{
lcd.setCursor(0,0);
lcd.print("TARIH= ");
lcd.print(myRTC.dayofmonth);
lcd.print("/");
lcd.print(myRTC.month);
lcd.print("/");
lcd.print(myRTC.year);
lcd.print("     ");
lcd.setCursor(0,1);

switch(myRTC.dayofweek)
      { case 1: lcd.print("pts.");break;
        case 2: lcd.print("sal.");break;
        case 3: lcd.print("crs.");break;
        case 4: lcd.print("prs.");break;
        case 5: lcd.print("cum.");break;
        case 6: lcd.print("cts.");break;
        case 7: lcd.print("paz.");break;
      }

lcd.print(" ");
lcd.print(myRTC.hours);
lcd.print(":");
lcd.print(myRTC.minutes);
lcd.print(":");
lcd.print(myRTC.seconds);
lcd.print("     ");
}






//CUMA GÜNÜ CUMA NAMAZINDAN 1 SAAT ÖNCE SELA OKUR
 if (myRTC.dayofweek==5 && suanzaman[3]==oglenezansaati - 1 && suanzaman[4]==oglenezandakikasi && suanzaman[5]==oglenezansaniyesi)
 { 
  digitalWrite(anficalistir, HIGH);
  lcd.setCursor(0,0);
  lcd.print("SELAA OKUNUYOR..    ");
  lcd.setCursor(0,1);
  lcd.print(" CUMA SELASI ");
  lcd.print(myRTC.hours); 
  lcd.print(":"); 
  lcd.print(myRTC.minutes);
  lcd.print(":"); 
  lcd.print(myRTC.seconds); 

  tmrpcm.play("6.wav"); 
  tmrpcm.volume(1);
  tmrpcm.quality(1);
  delay(378000);
  tmrpcm.stopPlayback();
  tmrpcm.disable();

  digitalWrite(anficalistir, LOW); 
  lcd.setCursor(0,0);
  lcd.print("  CUMA           ");
  lcd.setCursor(0,1);
  lcd.print("SELAA OKUNDU....     ");

  delay(60000);
  resetfunc();
 } 
//--------


//PERŞEMBE GÜNÜ AKŞAM EZANI İLE CUMA SABAH EZANINA KADAR AKTİF OLUR (MİNARE IŞIKLARINI YAKMAK İÇİN KULLANILIR)
 if (myRTC.dayofweek==4 && suanzaman[3]==aksamezansaati && suanzaman[4]==aksamezandakikasi && suanzaman[5]==aksamezansaniyesi)
 {digitalWrite(minareisikyak, HIGH);}
 else if (myRTC.dayofweek==5 && suanzaman[3]==sabahezansaati && suanzaman[4]==sabahezandakikasi && suanzaman[5]==sabahezansaniyesi)
 {digitalWrite(minareisikyak, LOW);}
//--------

//RAMAZAN AYI BOYUNCA İFTAR SAATI İLE SAHUR SAATI ARASINDA AKTİF OLUR (MİNARE IŞIKLARINI YAKMAK İÇİN KULLANILIR)
 if (ramazanayimi==1 && suanzaman[3]==aksamezansaati && suanzaman[4]==aksamezandakikasi && suanzaman[5]==aksamezansaniyesi)
 {digitalWrite(minareisikyak, HIGH);}
 else if (ramazanayimi==1 && suanzaman[3]==sabahezansaati && suanzaman[4]==sabahezandakikasi && suanzaman[5]==sabahezansaniyesi)
 {digitalWrite(minareisikyak, LOW);}
//--------




}